package org.xdoclet.plugin.ejb.qtags;

public class EjbEnvEntryTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbEnvEntryTag {
    public static final String NAME = "ejb.env-entry";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"description",
		"name",
		"type",
		"value",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbEnvEntryTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbEnvEntryTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getName_() {
		boolean required = true;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getType() {
		boolean required = false;
        String result = getNamedParameter("type");
        if(required && result == null) {
            bomb("type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "java.lang.String";
        }

		if (result != null) {
	            if( !(false || result.equals("java.lang.Boolean")|| result.equals("java.lang.Byte")|| result.equals("java.lang.Character")|| result.equals("java.lang.String")|| result.equals("java.lang.Short")|| result.equals("java.lang.Integer")|| result.equals("java.lang.Long")|| result.equals("java.lang.Float")|| result.equals("java.lang.Double")) ) {
	                // todo we should say what file and line number too
	                bomb("type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getValue_() {
		boolean required = false;
        String result = getNamedParameter("value");
        if(required && result == null) {
            bomb("value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getDescription();
        getName_();
        getType();
        getValue_();
    }

    public void validateModel() {
        // check uniqueness
    }
}